| Version: 3.3.1

Protected Member Functions | List of all members
wxWrapperInputStream Class Reference
Class List by Category » Streams

`#include <wx/stream.h>`

Inheritance diagram for wxWrapperInputStream:
[legend]

## Detailed Description

A wrapper input stream is a kind of filter stream which forwards all the operations to its base stream.

This is useful to build utility classes such as wxFSInputStream.

Note
  The interface of this class is the same as that of wxInputStream. Only a constructor differs and it is documented below.

##

Library: wxBase
Category: Streams

See also
  wxFSInputStream, wxFilterInputStream

Since
  2.9.4

## Public Member Functions
| wxWrapperInputStream (wxInputStream &stream)
| Initializes a wrapper stream. More...
| wxWrapperInputStream (wxInputStream *stream)
| Initializes a wrapper stream. More...
Public Member Functions inherited from wxFilterInputStream
| wxFilterInputStream (wxInputStream &stream)
| Initializes a "filter" stream. More...
| wxFilterInputStream (wxInputStream *stream)
| Initializes a "filter" stream. More...
Public Member Functions inherited from wxInputStream
| wxInputStream ()
| Creates a dummy input stream. More...
virtual | ~wxInputStream ()
| Destructor. More...
virtual bool | CanRead () const
| Returns true if some data is available in the stream right now, so that calling Read() wouldn't block. More...
virtual bool | Eof () const
| Returns true after an attempt has been made to read past the end of the stream. More...
int | GetC ()
| Returns the first character in the input queue and removes it, blocking until it appears if necessary. More...
virtual size_t | LastRead () const
| Returns the last number of bytes read by the last input operation. More...
virtual char | Peek ()
| Returns the first character in the input queue without removing it. More...
virtual wxInputStream & | Read (void *buffer, size_t size)
| Reads the specified amount of bytes and stores the data in buffer. More...
wxInputStream & | Read (wxOutputStream &stream_out)
| Reads data from the input queue and stores it in the specified output stream. More...
bool | ReadAll (void *buffer, size_t size)
| Reads exactly the specified number of bytes into the buffer. More...
virtual wxFileOffset | SeekI (wxFileOffset pos, wxSeekMode mode=wxFromStart)
| Changes the stream current position. More...
virtual wxFileOffset | TellI () const
| Returns the current stream position or wxInvalidOffset if it's not available (e.g. More...
size_t | Ungetch (const void *buffer, size_t size)
| This function is only useful in read mode. More...
bool | Ungetch (char c)
| This function acts like the previous one except that it takes only one character: it is sometimes shorter to use than the generic function. More...
Public Member Functions inherited from wxStreamBase
| wxStreamBase ()
| Creates a dummy stream object. More...
virtual | ~wxStreamBase ()
| Destructor. More...
wxStreamError | GetLastError () const
| This function returns the last error. More...
virtual wxFileOffset | GetLength () const
| Returns the length of the stream in bytes. More...
virtual size_t | GetSize () const
| This function returns the size of the stream. More...
virtual bool | IsOk () const
| Returns true if no error occurred on the stream. More...
virtual bool | IsSeekable () const
| Returns true if the stream supports seeking to arbitrary offsets. More...
void | Reset (wxStreamError error=wxSTREAM_NO_ERROR)
| Resets the stream state. More...
bool | operator! () const
| Returns the opposite of IsOk(). More...

## Protected Member Functions
| wxWrapperInputStream ()
| Default constructor, use InitParentStream() to finish initialization. More...
void | InitParentStream (wxInputStream &stream)
| Set up the wrapped stream for an object initialized using the default constructor. More...
void | InitParentStream (wxInputStream *stream)
| Set up the wrapped stream for an object initialized using the default constructor. More...
Protected Member Functions inherited from wxInputStream
size_t | OnSysRead (void *buffer, size_t bufsize)=0
| Internal function. More...
Protected Member Functions inherited from wxStreamBase
virtual wxFileOffset | OnSysSeek (wxFileOffset pos, wxSeekMode mode)
| Internal function. More...
virtual wxFileOffset | OnSysTell () const
| Internal function. More...

## Constructor & Destructor Documentation

## ◆ wxWrapperInputStream() [1/3]

wxWrapperInputStream::wxWrapperInputStream | ( | wxInputStream & | stream | ) |

Initializes a wrapper stream.

If the parent stream is passed as a pointer then the new wrapper stream takes ownership of it. If it is passed by reference then it does not.

## ◆ wxWrapperInputStream() [2/3]

wxWrapperInputStream::wxWrapperInputStream | ( | wxInputStream * | stream | ) |

Initializes a wrapper stream.

If the parent stream is passed as a pointer then the new wrapper stream takes ownership of it. If it is passed by reference then it does not.

## ◆ wxWrapperInputStream() [3/3]

wxWrapperInputStream::wxWrapperInputStream | ( |  | ) |
| protected

Default constructor, use InitParentStream() to finish initialization.

This constructor can be used by the derived classes from their own constructors when the parent stream can't be specified immediately. The derived class must call InitParentStream() later to do it.

## Member Function Documentation

## ◆ InitParentStream() [1/2]

void wxWrapperInputStream::InitParentStream | ( | wxInputStream & | stream | ) |
| protected

Set up the wrapped stream for an object initialized using the default constructor.

The ownership logic is the same as for the non-default constructor, i.e. this object takes ownership of the stream if it's passed by pointer but not if it's passed by reference.

## ◆ InitParentStream() [2/2]

void wxWrapperInputStream::InitParentStream | ( | wxInputStream * | stream | ) |
| protected

Set up the wrapped stream for an object initialized using the default constructor.

The ownership logic is the same as for the non-default constructor, i.e. this object takes ownership of the stream if it's passed by pointer but not if it's passed by reference.